diff -r 0cc9d22c3732 ChangeLog
--- a/ChangeLog	Thu Aug 27 15:18:51 2009 +0100
+++ b/ChangeLog	Fri Aug 28 11:24:47 2009 -0600
@@ -1,3 +1,8 @@
+2009-08-28  Jerry James  <james@xemacs.org>
+
+	* configure.ac: Check for external giflib instead of using builtin
+	gif support.  Remove "(builtin)" from relevant strings.
+
 2009-07-28  Mike Sperber  <mike@xemacs.org>
 
 	* Makefile.in.in: Don't install silly symlinks when $(prefix) !=
diff -r 0cc9d22c3732 configure.ac
--- a/configure.ac	Thu Aug 27 15:18:51 2009 +0100
+++ b/configure.ac	Fri Aug 28 11:24:47 2009 -0600
@@ -802,7 +802,7 @@
                         Requires the compface package.]),
 	[], [])
 XE_MERGED_ARG([gif],
-	AS_HELP_STRING([--with-gif],[Compile without the (builtin) support for GIF images.]),
+	AS_HELP_STRING([--with-gif],[Compile with support for GIF images.]),
 	[], [])
 dnl
 XE_HELP_SUBSECTION([Sound options])
@@ -4124,11 +4124,18 @@
     XE_PREPEND(-lcompface, libs_x)
   fi
 
-  dnl For a brief period we had the GIF code split out into a separate library,
-  dnl but patent problems, etc. sort of squashed that idea.
-  dnl We default to building with builtin GIF decoding
+  dnl autodetect GIF
+  test -z "$with_gif" && { AC_CHECK_HEADER(gif_lib.h, , with_gif=no) }
   if test "$with_gif" != "no"; then
-    with_gif="yes"
+    dnl Versions of libgif and libungif prior to the introduction of
+    dnl EGifPutExtensionLast caused Emacs crashes.  We'll require that
+    dnl function, too, in hopes that we can avoid similar crashes.
+    AC_CHECK_LIB(gif, EGifPutExtensionLast,
+      [XE_PREPEND(-lgif, libs_x)],
+      [AC_CHECK_LIB(ungif, EGifPutExtensionLast,
+        [XE_PREPEND(-lungif, libs_x)], with_gif=no)])
+  fi
+  if test "$with_gif" != "no"; then
     AC_DEFINE(HAVE_GIF)
   fi
 
@@ -6096,7 +6103,7 @@
 
 echo "
 Images:"
-test "$with_gif" = yes && echo "  Compiling in support for GIF  images (builtin)."
+test "$with_gif" = yes && echo "  Compiling in support for GIF images."
 if test "$with_xpm" = yes; then
   echo "  Compiling in support for XPM  images."
 elif test "$with_x11" = yes; then
diff -r 0cc9d22c3732 lisp/ChangeLog
--- a/lisp/ChangeLog	Thu Aug 27 15:18:51 2009 +0100
+++ b/lisp/ChangeLog	Fri Aug 28 11:24:47 2009 -0600
@@ -1,3 +1,8 @@
+2009-08-28  Jerry James  <james@xemacs.org>
+
+	* glyphs.el (make-image-specifier): Remove ancient comment about
+	lack of support for animated GIFs.
+
 2009-08-27  Aidan Kehoe  <kehoea@parhasard.net>
 
 	* cl.el (bytecomp-load-hook): New.
diff -r 0cc9d22c3732 lisp/glyphs.el
--- a/lisp/glyphs.el	Thu Aug 27 15:18:51 2009 +0100
+++ b/lisp/glyphs.el	Fri Aug 28 11:24:47 2009 -0600
@@ -81,8 +81,7 @@
    Not currently implemented -- it's treated like `string'.
    [:data] (text)
 `gif'
-   A GIF87 or GIF89 image; only if GIF support was compiled into this
-   XEmacs.  NOTE: Only the first frame of animated gifs will be displayed.
+   A GIF87 or GIF89 image; only if GIF support was compiled into this XEmacs.
    [:data, :file] (color-pixmap, pointer)
 `jpeg'
    A JPEG image; only if JPEG support was compiled into this XEmacs.
@@ -1240,4 +1239,4 @@
 (unintern 'init-glyphs) ;; This was dump time thing, no need to keep the
 			;; function around.
 
-;;; glyphs.el ends here.
\ No newline at end of file
+;;; glyphs.el ends here.
diff -r 0cc9d22c3732 man/ChangeLog
--- a/man/ChangeLog	Thu Aug 27 15:18:51 2009 +0100
+++ b/man/ChangeLog	Fri Aug 28 11:24:47 2009 -0600
@@ -1,3 +1,14 @@
+2009-08-28  Jerry James  <james@xemacs.org>
+
+	* beta.texi (Building XEmacs from a full distribution): Remove
+	"(builtin)" from GIF line in example Installation.
+	(Reporting Problems): Recommend taking screenshots as a PNG
+	instead of a GIF.
+	* internals/internals.texi (A Summary of the Various XEmacs Modules):
+	Remove GIF-related files.
+	* lispref/glyphs.texi (Image Instantiator Formats): Remove remark
+	about builtin GIF support.
+
 2009-08-11  Aidan Kehoe  <kehoea@parhasard.net>
 
 	* lispref/numbers.texi (Bigfloat Basics): 
diff -r 0cc9d22c3732 nt/ChangeLog
--- a/nt/ChangeLog	Thu Aug 27 15:18:51 2009 +0100
+++ b/nt/ChangeLog	Fri Aug 28 11:24:47 2009 -0600
@@ -1,3 +1,10 @@
+2009-08-28  Jerry James  <james@xemacs.org>
+
+	* config.inc.samp: Add GIF_DIR for external GIF support.
+	* xemacs.mak: Convert from internal to external GIF support.
+	* xemacs.dsp: Drop internal GIF source files.
+	* README: Remove remark about internal GIF support.
+
 2009-05-18  Stephen J. Turnbull  <stephen@xemacs.org>
 
 	* XEmacs 21.5.29 "garbanzo" is released.
diff -r 0cc9d22c3732 nt/README
--- a/nt/README	Thu Aug 27 15:18:51 2009 +0100
+++ b/nt/README	Fri Aug 28 11:24:47 2009 -0600
@@ -236,8 +236,6 @@
        Similarly for JPEG, TIFF, etc. support.
 
        For PNG support, you also need to specify ZLIB_DIR.
-       For GIF support, no directory is necessary as the appropriate code
-       is already in XEmacs.
 
        If you want to use the DLL version of the Sleepycat DB library,
        set BUILD_DATABASE_SHARED to 1.  You will have to have the DLL
diff -r 0cc9d22c3732 nt/config.inc.samp
--- a/nt/config.inc.samp	Thu Aug 27 15:18:51 2009 +0100
+++ b/nt/config.inc.samp	Fri Aug 28 11:24:47 2009 -0600
@@ -45,8 +45,10 @@
 HAVE_XPM=1
 XPM_DIR=$(OPTIONAL_LIBRARY_DIR)\xpm-3.4k
 
-# Set this to enable GIF support (built-in).
+# Set this to enable GIF support, and specify the directory containing giflib.
+# Get the latest version from http://sourceforge.net/projects/giflib/.
 HAVE_GIF=1
+GIF_DIR=$(OPTIONAL_LIBRARY_DIR)\giflib-4.1.6
 
 # Set this to enable PNG support (virtually mandatory), and specify the
 # directories containing png and zlib.  Get the latest version of PNG from
diff -r 0cc9d22c3732 nt/xemacs.dsp
--- a/nt/xemacs.dsp	Thu Aug 27 15:18:51 2009 +0100
+++ b/nt/xemacs.dsp	Fri Aug 28 11:24:47 2009 -0600
@@ -271,10 +271,6 @@
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\dgif_lib.c
-# End Source File
-# Begin Source File
-
 SOURCE="..\src\dialog-msw.c"
 # End Source File
 # Begin Source File
@@ -575,14 +571,6 @@
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\gif_io.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\gifrlib.h
-# End Source File
-# Begin Source File
-
 SOURCE="..\src\glyphs-eimage.c"
 # End Source File
 # Begin Source File
diff -r 0cc9d22c3732 nt/xemacs.mak
--- a/nt/xemacs.mak	Thu Aug 27 15:18:51 2009 +0100
+++ b/nt/xemacs.mak	Fri Aug 28 11:24:47 2009 -0600
@@ -142,7 +142,7 @@
 HAVE_XFACE=0
 !endif
 !if !defined(HAVE_GIF)
-HAVE_GIF=1
+HAVE_GIF=0
 !endif
 !if !defined(HAVE_GTK)
 HAVE_GTK=0
@@ -548,7 +548,8 @@
 !endif
 !if $(HAVE_GIF)
 OPT_DEFINES=$(OPT_DEFINES) -DHAVE_GIF
-OPT_OBJS=$(OPT_OBJS) $(OUTDIR)\dgif_lib.obj $(OUTDIR)\gif_io.obj
+OPT_INCLUDES=$(OPT_INCLUDES) -I"$(GIF_DIR)\lib"
+OPT_LIBS=$(OPT_LIBS) "$(GIF_DIR)\lib\libgif.lib"
 !endif
 !if $(HAVE_PNG)
 OPT_DEFINES=$(OPT_DEFINES) -DHAVE_PNG
diff -r 0cc9d22c3732 src/ChangeLog
--- a/src/ChangeLog	Thu Aug 27 15:18:51 2009 +0100
+++ b/src/ChangeLog	Fri Aug 28 11:24:47 2009 -0600
@@ -1,3 +1,21 @@
+2009-08-28  Jerry James  <james@xemacs.org>
+
+	* Makefile.in.in: Remove internal GIF object files from link.
+	* dgif_lib.c: Removed.
+	* gif_io.c: Removed.
+	* gifrlib.h: Removed.
+	* glyphs-eimage.c: Use external giflib instead of internal GIF
+	support.
+	(gif_instantiate_unwind): Use giflib's FreeSavedImages call
+	instead of the defunct GifFree.
+	(gif_read_from_memory): Adapt signature to giflib.
+	(gif_error_func): Removed.
+	(gif_memory_close): Removed.
+	(gif_decode_error_string): New function.
+	(gif_instantiate): Adapt to giflib API.
+	* libinterface.h: Include external giflib header instead of
+	internal GIF header.
+
 2009-08-24  Jerry James  <james@xemacs.org>
 
 	* lisp.h (INT_64_BIT): define as __int64 on WIN32.
diff -r 0cc9d22c3732 src/Makefile.in.in
--- a/src/Makefile.in.in	Thu Aug 27 15:18:51 2009 +0100
+++ b/src/Makefile.in.in	Fri Aug 28 11:24:47 2009 -0600
@@ -183,10 +183,6 @@
 event_unixoid_objs=event-unixoid.o
 #endif
 
-#ifdef HAVE_GIF
-gif_objs=dgif_lib.o gif_io.o
-#endif
-
 #ifdef HAVE_GPM
 gpm_objs=gpmevent.o
 #endif
@@ -285,7 +281,7 @@
  event-stream.o $(event_unixoid_objs) $(extra_objs) extents.o\
  faces.o file-coding.o fileio.o $(LOCK_OBJ) filemode.o floatfns.o fns.o \
  font-lock.o frame.o\
- gc.o general.o $(gif_objs) glyphs.o glyphs-eimage.o glyphs-shared.o\
+ gc.o general.o glyphs.o glyphs-eimage.o glyphs-shared.o\
  glyphs-widget.o $(gpm_objs) $(gtk_objs) $(gtk_gui_objs) $(gui_objs) \
  gutter.o\
  hash.o imgproc.o indent.o insdel.o intl.o\
diff -r 0cc9d22c3732 src/depend
--- a/src/depend	Thu Aug 27 15:18:51 2009 +0100
+++ b/src/depend	Fri Aug 28 11:24:47 2009 -0600
@@ -123,7 +123,6 @@
 data.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h bytecode.h casetab.h charset.h chartab.h compiler.h dumper.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h sysfloat.h syssignal.h text.h vdb.h
 debug.o: $(CONFIG_H) $(LISP_H) bytecode.h compiler.h debug.h dumper.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h text.h vdb.h
 device.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h compiler.h conslots.h console-impl.h console.h device-impl.h device.h devslots.h dumper.h elhash.h events.h faces.h frame-impl.h frame.h frameslots.h gc.h general-slots.h keymap.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h objects.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h sysdep.h syssignal.h systime.h text.h toolbar.h vdb.h window.h
-dgif_lib.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h gifrlib.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h sysfile.h text.h vdb.h
 dialog.o: $(CONFIG_H) $(LISP_H) compiler.h conslots.h console-impl.h console.h dumper.h frame-impl.h frame.h frameslots.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h redisplay.h specifier.h symeval.h symsinit.h text.h vdb.h
 dired.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h commands.h compiler.h dumper.h elhash.h gc.h general-slots.h intl-auto-encap-win32.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h ndir.h number-gmp.h number-mp.h number.h opaque.h regex.h symeval.h symsinit.h syntax.h sysdep.h sysdir.h sysfile.h syspwd.h systime.h syswindows.h text.h vdb.h
 doc.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h bytecode.h casetab.h charset.h chartab.h coding-system-slots.h compiler.h dumper.h file-coding.h gc.h general-slots.h insdel.h keymap.h lisp-disunion.h lisp-union.h lisp.h lrecord.h lstream.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h sysfile.h text.h vdb.h
@@ -158,8 +157,7 @@
 gc.o: $(CONFIG_H) $(LISP_H) backtrace.h buffer.h bufslots.h bytecode.h casetab.h charset.h chartab.h coding-system-slots.h compiler.h conslots.h console-impl.h console-stream.h console.h device.h dumper.h elhash.h events.h extents-impl.h extents.h file-coding.h frame-impl.h frame.h frameslots.h gc.h general-slots.h glyphs.h lisp-disunion.h lisp-union.h lisp.h lrecord.h lstream.h mc-alloc.h number-gmp.h number-mp.h number.h opaque.h process.h profile.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h sysdep.h sysfile.h systime.h text.h vdb.h window-impl.h window.h winslots.h
 general.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h text.h vdb.h
 getloadavg.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h sysfile.h syssignal.h text.h vdb.h
-gif_io.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h gifrlib.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h sysfile.h text.h vdb.h
-glyphs-eimage.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h coding-system-slots.h compiler.h conslots.h console-impl.h console.h device-impl.h device.h devslots.h dumper.h faces.h file-coding.h frame.h gc.h general-slots.h gifrlib.h glyphs.h lisp-disunion.h lisp-union.h lisp.h lrecord.h lstream.h mc-alloc.h number-gmp.h number-mp.h number.h objects-impl.h objects.h opaque.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h sysfile.h text.h vdb.h window-impl.h window.h winslots.h
+glyphs-eimage.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h coding-system-slots.h compiler.h conslots.h console-impl.h console.h device-impl.h device.h devslots.h dumper.h faces.h file-coding.h frame.h gc.h general-slots.h glyphs.h lisp-disunion.h lisp-union.h lisp.h lrecord.h lstream.h mc-alloc.h number-gmp.h number-mp.h number.h objects-impl.h objects.h opaque.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h sysfile.h text.h vdb.h window-impl.h window.h winslots.h
 glyphs-shared.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h compiler.h console.h dumper.h elhash.h faces.h frame.h gc.h general-slots.h glyphs.h imgproc.h insdel.h lisp-disunion.h lisp-union.h lisp.h lrecord.h lstream.h mc-alloc.h number-gmp.h number-mp.h number.h opaque.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h sysdep.h sysfile.h text.h vdb.h window-impl.h window.h winslots.h
 glyphs-widget.o: $(CONFIG_H) $(LISP_H) bytecode.h charset.h compiler.h conslots.h console-impl.h console.h device-impl.h device.h devslots.h dumper.h faces.h frame.h gc.h general-slots.h glyphs.h gui.h insdel.h lisp-disunion.h lisp-union.h lisp.h lrecord.h lstream.h mc-alloc.h number-gmp.h number-mp.h number.h objects.h opaque.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h text.h vdb.h window-impl.h window.h winslots.h
 glyphs.o: $(CONFIG_H) $(LISP_H) blocktype.h buffer.h bufslots.h casetab.h charset.h chartab.h compiler.h conslots.h console-impl.h console.h device-impl.h device.h devslots.h dumper.h elhash.h faces.h frame-impl.h frame.h frameslots.h gc.h general-slots.h glyphs.h gui.h insdel.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h objects-impl.h objects.h opaque.h rangetab.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h sysfile.h text.h vdb.h window-impl.h window.h winslots.h
@@ -182,7 +180,7 @@
 intl.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h text.h vdb.h
 keymap.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h bytecode.h casetab.h charset.h chartab.h compiler.h conslots.h console-impl.h console.h dumper.h elhash.h events.h extents.h frame.h gc.h general-slots.h insdel.h keymap.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h redisplay.h scrollbar.h specifier.h symeval.h symsinit.h systime.h text.h vdb.h window.h
 lastfile.o: $(CONFIG_H)
-libinterface.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h gifrlib.h libinterface.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h text.h vdb.h
+libinterface.o: $(CONFIG_H) $(LISP_H) compiler.h dumper.h gc.h general-slots.h libinterface.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h text.h vdb.h
 libsst.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h compiler.h dumper.h gc.h general-slots.h libsst.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h sound.h symeval.h symsinit.h sysfile.h text.h vdb.h
 line-number.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h compiler.h dumper.h gc.h general-slots.h line-number.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h number-gmp.h number-mp.h number.h symeval.h symsinit.h text.h vdb.h
 linuxplay.o: $(CONFIG_H) $(LISP_H) buffer.h bufslots.h casetab.h charset.h chartab.h compiler.h dumper.h gc.h general-slots.h lisp-disunion.h lisp-union.h lisp.h lrecord.h mc-alloc.h miscplay.h number-gmp.h number-mp.h number.h sound.h symeval.h symsinit.h sysfile.h syssignal.h systty.h text.h vdb.h
diff -r 0cc9d22c3732 src/glyphs-eimage.c
--- a/src/glyphs-eimage.c	Thu Aug 27 15:18:51 2009 +0100
+++ b/src/glyphs-eimage.c	Fri Aug 28 11:24:47 2009 -0600
@@ -34,6 +34,7 @@
    Many changes for color work and optimizations by Jareth Hein for 21.0
    Switch of GIF/JPEG/PNG to new EImage intermediate code by Jareth Hein for 21.0
    TIFF code by Jareth Hein for 21.0
+   GIF support changed to external giflib by Jerry James for 21.5
    TODO:
    Convert images.el to C and stick it in here?
    This file is really repetitious; can we refactor?
@@ -527,7 +528,7 @@
  *                               GIF                                  *
  **********************************************************************/
 
-#include "gifrlib.h"
+#include <gif_lib.h>
 
 static void
 gif_validate (Lisp_Object instantiator)
@@ -569,7 +570,7 @@
   if (data->giffile)
     {
       DGifCloseFile (data->giffile);
-      GifFree(data->giffile);
+      FreeSavedImages(data->giffile);
     }
   if (data->eimage)
     xfree (data->eimage, Binbyte *);
@@ -584,10 +585,10 @@
   Bytecount index;		/* Where are we?  */
 } gif_memory_storage;
 
-static Bytecount
-gif_read_from_memory (GifByteType *buf, Bytecount size, VoidPtr data)
+static int
+gif_read_from_memory (GifFileType *gif, GifByteType *buf, int size)
 {
-  gif_memory_storage *mem = (gif_memory_storage *) data;
+  gif_memory_storage *mem = (gif_memory_storage *) gif->UserData;
 
   if (size > (mem->len - mem->index))
     return -1;
@@ -596,26 +597,40 @@
   return size;
 }
 
-static int
-gif_memory_close (VoidPtr UNUSED (data))
+static const char *
+gif_decode_error_string ()
 {
-  return 0;
-}
-
-struct gif_error_struct
-{
-  const Extbyte *err_str;	/* return the error string */
-  jmp_buf setjmp_buffer;	/* for return to caller */
-};
-
-static void
-gif_error_func (const Extbyte *err_str, VoidPtr error_ptr)
-{
-  struct gif_error_struct *error_data = (struct gif_error_struct *) error_ptr;
-
-  /* return to setjmp point */
-  error_data->err_str = err_str;
-  longjmp (error_data->setjmp_buffer, 1);
+  switch (GifLastError ())
+    {
+    case D_GIF_ERR_OPEN_FAILED:
+      return "GIF error: unable to open";
+    case D_GIF_ERR_READ_FAILED:
+      return "GIF error: read failed";
+    case D_GIF_ERR_NOT_GIF_FILE:
+      return "GIF error: not a GIF file";
+    case D_GIF_ERR_NO_SCRN_DSCR:
+      return "GIF error: no Screen Descriptor detected";
+    case D_GIF_ERR_NO_IMAG_DSCR:
+      return "GIF error: no Image Descriptor detected";
+    case D_GIF_ERR_NO_COLOR_MAP:
+      return "GIF error: no global or local color map";
+    case D_GIF_ERR_WRONG_RECORD:
+      return "GIF error: wrong record type";
+    case D_GIF_ERR_DATA_TOO_BIG:
+      return "GIF error: image is larger than indicated by header";
+    case D_GIF_ERR_NOT_ENOUGH_MEM:
+      return "GIF error: out of memory";
+    case D_GIF_ERR_CLOSE_FAILED:
+      return "GIF error: failed to close file";
+    case D_GIF_ERR_NOT_READABLE:
+      return "GIF error: file is not readable";
+    case D_GIF_ERR_IMAGE_DEFECT:
+      return "GIF error: image is defective";
+    case D_GIF_ERR_EOF_TOO_SOON:
+      return "GIF error: image EOF detected before image complete";
+    default:
+      return "GIF error: unknown error";
+    }
 }
 
 static void
@@ -630,7 +645,6 @@
   struct gif_unwind_data unwind;
   int speccount = specpdl_depth ();
   gif_memory_storage mem_struct;
-  struct gif_error_struct gif_err;
   Binbyte *bytes;
   Bytecount len;
   int height = 0;
@@ -646,35 +660,19 @@
 
     assert (!NILP (data));
 
-    if (!(unwind.giffile = GifSetup()))
-      signal_image_error ("Insufficient memory to instantiate GIF image", instantiator);
-
-    /* set up error facilities */
-    if (setjmp(gif_err.setjmp_buffer))
-      {
-	/* An error was signaled. No clean up is needed, as unwind handles that
-	   for us.  Just pass the error along. */
-	Ibyte *interr;
-	Lisp_Object errstring;
-	EXTERNAL_TO_C_STRING (gif_err.err_str, interr, Qnative);
-	errstring = build_msg_intstring (interr);
-	signal_image_error_2 ("GIF decoding error", errstring, instantiator);
-      }
-    GifSetErrorFunc(unwind.giffile, (Gif_error_func)gif_error_func, (VoidPtr)&gif_err);
-
     TO_EXTERNAL_FORMAT (LISP_STRING, data, ALLOCA, (bytes, len), Qbinary);
     mem_struct.bytes = bytes;
     mem_struct.len = len;
     mem_struct.index = 0;
-    GifSetReadFunc(unwind.giffile, gif_read_from_memory, (VoidPtr)&mem_struct);
-    GifSetCloseFunc(unwind.giffile, gif_memory_close, (VoidPtr)&mem_struct);
-    DGifInitRead(unwind.giffile);
+    unwind.giffile = DGifOpen (&mem_struct, gif_read_from_memory);
+    if (unwind.giffile == NULL)
+      signal_image_error (gif_decode_error_string (), instantiator);
 
     /* Then slurp the image into memory, decoding along the way.
        The result is the image in a simple one-byte-per-pixel
-       format (#### the GIF routines only support 8-bit GIFs,
-       it appears). */
-    DGifSlurp (unwind.giffile);
+       format. */
+    if (DGifSlurp (unwind.giffile) == GIF_ERROR)
+      signal_image_error (gif_decode_error_string (), instantiator);
   }
 
   /* 3. Now create the EImage(s) */
@@ -748,7 +746,7 @@
   if (unwind.giffile->ImageCount > 1)
     {
     /* See if there is a timeout value. In theory there could be one
-       for every image - but that makes the implementation way to
+       for every image - but that makes the implementation way too
        complicated for now so we just take the first. */
       unsigned short timeout = 0;
       Lisp_Object tid;
diff -r 0cc9d22c3732 src/libinterface.h
--- a/src/libinterface.h	Thu Aug 27 15:18:51 2009 +0100
+++ b/src/libinterface.h	Fri Aug 28 11:24:47 2009 -0600
@@ -24,7 +24,7 @@
 #define INCLUDED_libinterface_h_
 
 #ifdef HAVE_GIF
-#include "gifrlib.h"
+#include <gif_lib.h>
 #endif /* HAVE_GIF */
 
 #ifdef HAVE_PNG
